{% extends "front/base_logged.html" %}
{% load i18n %}
{% load static %}
{% load render_table from django_tables2 %}

{% block content %}

    {% include "wizard/header.html" %}

    <div class="panel panel-default">
      <div class="panel-heading">
          <strong>{% trans "Definir Parâmetros Hidrodinâmicos de entrada" %}</strong>
          <div class="help">
              <button id="help_btn" type="button" class="btn btn-primary btn-xs" data-toggle="tooltip" data-placement="top" title="{% trans 'Mais info' %}" data-title="{% trans 'Mais info' %}" data-title_alt="{% trans 'Menos info' %}">
                  <span class="glyphicon glyphicon-question-sign"></span>
              </button>
              <button id="tips_btn" type="button" class="btn btn-primary btn-xs" data-toggle="tooltip" data-placement="top" title="{% trans 'Dicas' %}">
                  <span class="glyphicon glyphicon-info-sign"></span>
              </button>
          </div>
      </div>
      <div id="help" class="alert alert-warning cst_hide">
          {% include "wizard/help_text/step_param.html" %}
      </div>
      <div class="panel-body">
        {% blocktrans trimmed %}
        Para o modelo escolhido é necessário definir todos os parâmetros hidrodinâmicos de entrada para a simulação deste modelo.
          Neste passo o utilizador partirá de um ficheiro de parâmetros hidrodinâmicos pré-definido e poderá customizar alguns dos parâmetros hidrodinâmicos.
        {% endblocktrans %}
        {% if 'yes' in waves_type %}
        {% blocktrans trimmed %}
          Para corridas do tipo Ondas e correntes é necessário também definir os parâmetros hidrodinâmicos para o ficheiro 'wwminput.nml'.
        {% endblocktrans %}
        {% endif %}
      </div>
    </div>

    {% if errors %}
    <div class="alert alert-danger">
        <ul>
            {% for error in errors %}
            <li>{{ error }}</li>
            {% endfor %}
        </ul>
    </div>
    {% endif %}

    

    <form class="form" method="post" {% if file_upload_allowed %}enctype="multipart/form-data"{% endif %}>{% csrf_token %}
        <div class="forms">
            {% for field in forms.0 %}
            <div class="fieldWrapper">
                {{ field.label_tag }} {{ field }}
                {% if field.help_text %}
                <h5 class="text-info">{{ field.help_text|safe }}</h5>
                {% endif %}
                <h5 class="text-warning">{{ field.errors }}</h5>
            </div>
            {% endfor %}
        </div>
        {% if 'yes' in waves_type %}
        <ul class="nav nav-pills nav-justified">
            <li class="active">
                <a href="#flux" role="tab" data-toggle="tab">{% trans "Circulação" %} (param.nml)</a>
            </li>
            <li>
                <a href="#waves" role="tab" data-toggle="tab">{% trans "Ondas" %} (wwminput.nml)</a>
            </li>
        </ul>

        <div id="tabs" class="tab-content">
            <div id="flux" class="tab-pane active">
        {% endif %}

        {% if deploy_id %}
        <a class="btn btn-default" target="_blank" href="{% url 'front:get_definition' name='param' %}" title="{% trans 'Abrir numa nova janela' %}"><span class="glyphicon glyphicon-eye-open"></span> {% trans " Ver Template" %} param.nml</a>
        {% else %}
        {% if request.session.deploy_id %}
        <a class="btn btn-default" target="_blank" href="{% url 'front:get_definition' name='param' %}" title="{% trans 'Abrir numa nova janela' %}"><span class="glyphicon glyphicon-eye-open"></span> {% trans " Abrir Template" %} param.nml</a>
        {% else %}
        <a class="btn btn-default" target="_blank" href="{% url 'front:get_definition' name='param' %}" title="{% trans 'Abrir numa nova janela' %}"><span class="glyphicon glyphicon-eye-open"></span> {% trans " Abrir Template" %} param.nml</a>
        {% endif %}
        <br>
        {% endif %}

        <div id="flux" class="forms">
            {% for field in forms.1 %}
            <div class="fieldWrapper">
                {{ field.label_tag }} {{ field }}
                {% if field.help_text %}
                <h5 class="text-info">{{ field.help_text|safe }}</h5>
                {% endif %}
                <h5 class="text-warning">{{ field.errors }}</h5>
            </div>
            {% endfor %}
        </div>

        {% if file_upload_allowed %}
        <div class="forms">
            {% for form in forms %}
            {% if 'file' in form %}
            {% for field in form %}
            <div class="fieldWrapper">
                {{ field.label_tag }} {{ field }}
                {% if field.help_text %}
                <h5 class="text-info">{{ field.help_text|safe }}</h5>
                {% endif %}
                <h5 class="text-warning">{{ field.errors }}</h5>
            </div>
            {% endfor %}
            {% endif %}
            {% endfor %}
        </div>
        {% endif %}

        {% if 'yes' in waves_type %}
            </div>
            <div id="waves" class="tab-pane">

                {% if deploy_id %}
                <a class="btn btn-default" target="_blank" href="{% url 'front:get_definition' name='wwminput' %}" title="{% trans 'Abrir numa nova janela' %}"><span class="glyphicon glyphicon-eye-open"></span> {% trans " Ver Template" %} wwminput.nml</a>
                {% else %}
                {% if request.session.deploy_id %}
                <a class="btn btn-default" target="_blank" href="{% url 'front:get_definition' name='wwminput' %}"><span class="glyphicon glyphicon-eye-open"></span> {% trans " Abrir Template" %} wwminput.nml</a>
                {% else %}
                <a class="btn btn-default" target="_blank" href="{% url 'front:get_definition' name='wwminput' %}" title="{% trans 'Abrir numa nova janela' %}"><span class="glyphicon glyphicon-eye-open"></span> {% trans " Abrir Template" %} wwminput.nml</a>
                {% endif %}
                <br>
                {% endif %}
                <!-- ver este codigo -->
                <div class="forms" style="display:none;">
                    {% for field in forms_wwm.0 %}
                    <div class="fieldWrapper">
                        {{ field.label_tag }} {{ field }}
                        {% if field.help_text %}
                        <h5 class="text-info">{{ field.help_text|safe }}</h5>
                        {% endif %}
                        <h5 class="text-warning">{{ field.errors }}</h5>
                    </div>
                    {% endfor %}
                </div>

                <div class="forms">
                    {% for field in forms_wwm.1 %}
                    <div class="fieldWrapper">
                        {{ field.label_tag }} {{ field }}
                        {% if field.help_text %}
                        <h5 class="text-info">{{ field.help_text|safe }}</h5>
                        {% endif %}
                        <h5 class="text-warning">{{ field.errors }}</h5>
                    </div>
                    {% endfor %}
                </div>
            </div>
        {% endif %}

        <div class="row btnmenu">
            <div class="col-xs-6">
                <button id="btn_prev" type="button" class="btn btn-default" data-step="4" data-intro="{% trans 'Pode sempre revisitar passos anteriores' %}">
                    <span class="glyphicon glyphicon-arrow-left"></span> {% trans "Anterior" %}
                </button>
                <button id="btn_restart" class="btn btn-default" data-step="3" data-intro="{% trans 'ou limpe e recomeçe o passo' %}" data-toggle="tooltip" data-placement="top" title="{% trans 'Reset do passo e apaga passos posteriores' %}">{% trans "Recomeçar passo" %}</button>
            </div>
            <div class="col-xs-6 text-right">
                  {% if request.session.last_step < step %}
                <button id="btn_submit" type="submit" name="next" class="btn btn-primary" data-step="2" data-intro="{% trans 'Prima o botão' %}">
                    {% trans "Concluir passo" %} <span class="glyphicon glyphicon-arrow-right"></span>
                </button>
                {% else %}
                <button id="btn_submit" type="submit" name="edit" class="btn btn-primary" data-toggle="tooltip" data-placement="top" title="{% trans 'Aplicar alterações efetuadas ao passo' %}" data-step="2" data-intro="{% trans 'Se efetuar alterações ao passo prima este botão para as guardar' %}">
                    {% trans "Guardar alterações" %}
                </button>
                <button id="btn_next" class="btn btn-default" data-step="5" data-intro="{% trans 'Ou passos posteriores' %}">
                    {% trans "Seguinte" %} <span class="glyphicon glyphicon-arrow-right"></span>
                </button>
                {% endif %}
            </div>
        </div>
    </form>

    <script type="text/javascript">
        // Function that toggles Visibility of Forms
        function toggleForms() {
            // Hide all forms but first form (choice form) and table
            var choices = $('#flux .forms');
            for (var i=1; i<choices.length; i++) console.log(choices[i]);

            let custom_inputs =  document.getElementsByClassName('user_customizable');

            for(var i = 0; i < custom_inputs.length; i++){
		        console.log(custom_inputs[i].disabled)
                if(custom_inputs[i].disabled == true)
                    custom_inputs[i].disabled = false;
                else
                    custom_inputs[i].disabled = true;
            }

            console.log(custom_inputs);  

            // Show choice corresponding to selection
            var choice = $('[name="parchoice"]:checked').val();
            switch (choice)
            {
                case "D":
                    $('#pardefault_table').show();
                    $('#pardefault_table').closest(".table-container").show();
                    break;
                case "C":
                    $('#pardefault_table').hide();
                    $('#pardefault_table').closest(".table-container").hide();
                    $(choices[1]).show();
                    break;
                case "U":
                    $('#pardefault_table').hide();
                    $('#pardefault_table').closest(".table-container").hide();
                    $(choices[2]).show();
                    break;
                default:
            }

            // Remove focus
            $('[name="parchoice"]:checked').blur();

            {% if "yes" in waves_type %}
            // Hide all forms but first form (choice form) and table
            var wav_choices = $('#waves .forms');
            for (var i=1; i<choices.length; i++) console.log(choices[i]); 

            console.log(custom_inputs);  

            // Show choice corresponding to selection
            var choice = $('[name="parchoice"]:checked').val();
            switch (choice)
            {
                case "D":
                    $('#wwmdefault_table').show();
                    $('#wwmdefault_table').closest(".table-container").show();
                    break;
                case "C":
                    $('#wwmdefault_table').hide();
                    $('#wwmdefault_table').closest(".table-container").hide();
                    $(choices[1]).show();
                    break;
                case "U":
                    $('#wwmdefault_table').hide();
                    $('#wwmdefault_table').closest(".table-container").hide();
                    $(choices[2]).show();
                    break;
                default:
            }

            // Remove focus
            $('[name="parchoice"]:checked').blur();
            {% endif %}
        }
        /*
        function toggleForms_wwm() {
            // Hide all forms but first form (choice form) and table
            var choices = $('#waves .forms');
            for (var i=1; i<choices.length; i++) $(choices[i]).hide();

            // Show choice corresponding to selection
            var choice = $('[name="wwmchoice"]:checked').val();
            switch (choice)
            {
                case "D":
                    $('#wwmdefault_table').show();
                    $('#wwmdefault_table').closest(".table-container").show();
                    break;
                case "C":
                    $('#wwmdefault_table').hide();
                    $('#wwmdefault_table').closest(".table-container").hide();
                    $(choices[1]).show();
                    break;
                case "U":
                    $('#wwmdefault_table').hide();
                    $('#wwmdefault_table').closest(".table-container").hide();
                    $(choices[2]).show();
                    break;
                default:
            }

            // Remove focus
            $('[name="wwmchoice"]:checked').blur();
        } */

        // Return input field value
        function getVal(field) {
            if ($('[name="' + field + '"]').is('input[type="radio"]')) {
                return $('[name="' + field + '"]:checked').val();
            } else if ($('[name="' + field + '"]').is('input[type="checkbox"]')) {
                return ($('[name="' + field + '"]').is(":checked")) ? "1" : "0";
            } else {
                return $('[name="' + field + '"]').val();
            }
        }

        // Validate change on field
        function validateField(fieldname, del, targetval) {
            var field = $('[name="' + fieldname + '"]');
            var val = field.val();

            var targetval_str = targetval;
            if (typeof targetval === "string") {
                // Field's value depends on an operation
                var fsaux = targetval.split(new RegExp('[-\*\/=]', 'g'));

                for (var i=0; i<fsaux.length; i++) {
                    var faux = fsaux[i];
                    if (faux.indexOf('$') > -1) {
                        // Depends on another field, replace field reference with its value
                        // Get value to replace
                        var name = faux.replace('$', '');
                        if (name == name.toLowerCase()) {
                            name = 'cst-' + name;
                        } else {
                            // If field name in uppercase then its a wwm field
                            name = 'cst_wwm-' + name;
                        }
                        var dvalue = $('[name="' + name + '"]').val();
                        if (typeof dvalue != "undefined") targetval = targetval.replace(fsaux[i], dvalue);
                    }
                }
            }

            console.log(fieldname);
            console.log(del);
            console.log(targetval);

            // Transform to operator
            var del_str = del;
            if (del == '=') del = '==';

            if (del == '%') {
                // Evaluate if Divisable
                if (!Number.isInteger(targetval/val)) {
                    field.val('');
                    field.attr('title', '{% trans "O valor tem de ser divisível por" %} ' + targetval + '.');
                } else {
                    field.removeAttr('title', '');
                }
            } else if (del == 'isInteger') {
                if (!Number.isInteger(eval(targetval))) {
                    field.val('');
                    field.attr('title', '{% trans "O valor de" %} ' + targetval_str + ' {% trans "tem de ser inteiro" %}.');
                } else {
                    field.removeAttr('title', '');
                }
            } else {
                if (eval(val + del + targetval)) {
                    field.removeAttr('title', '');
                } else {
                    field.val('');
                    field.attr('title', '{% trans "O valor tem de ser" %} ' + del_str + ' {% trans "a" %} ' + targetval + '.');
                }
            }

            if(fieldname == 'cst-dt' || fieldname == 'cst-nstep_wwm'){
                dt = getVal('cst-dt');
                nstep_wwm = getVal('cst-nstep_wwm');

                console.log("dt");
                console.log(dt);
                console.log("nstep_wwm");
                console.log(nstep_wwm);

                var dt_nstep_wwm = parseInt(dt)*parseInt(nstep_wwm);

                var proc_deltc_field = $('[name="' + 'cst_wwm-PROC_DELTC' + '"]');
                proc_deltc_field.val(dt_nstep_wwm.toString());

            }
        }

        // Check if field has more load conditions that must be met
        function loadConditions(field) {
            var json = JSON.parse($(field).attr('data-ruleset').replace(/'/g, '"'));
            var functions = json.functions;
            var conditions = functions['load']['eval'];
            var arr1 = conditions.replace(new RegExp('[()/:?]', 'g'), '').split(new RegExp('[&|/:?]', 'g'));
            // loop through evaluate conditions
            for (var i=0; i<arr1.length; i++) {
                var arr2 = arr1[i].split(new RegExp('[<=>/:?]', 'g'));
                if (arr2[0].length>0) {
                    // get element name
                    var cfield = arr2[0];
                    // get element value
                    var value = getVal('cst-' + cfield);
                    // replace element name with value
                    conds = arr1[i].replace(cfield, value);
                    // replace on general evaluate condition
                    conditions = conditions.replace(arr1[i], conds);
                }
            }
            return conditions;
        }

        // Tooltips Setup (for Intro.js)
        $('[name="parchoice"]').closest(".fieldWrapper").attr("data-step", 1);
        $('[name="parchoice"]').closest(".fieldWrapper").attr("data-intro", "{% trans 'Selecione a opção para a definição dos parâmetros hidrodinâmicoss de entrada, se optar por customizar, todos os campos do formulário terão de estar preenchidos' %}");

        // Submit Step event
        $('#btn_submit').click(function(e){
            var flagok = true;
            var msg = '';

            try {
                {% if 'yes' in waves_type %}
                var all_par_inputs = '#flux input, #flux select';
                {% else %}
                var all_par_inputs = '.form input, .form select';
                {% endif %}
                var parchoice = $('[name="parchoice"]:checked').val();
                if (parchoice == 'D') {
                    // reject values from inputs in 'C' parchoice
                    $(all_par_inputs).removeAttr('required');
                } else if (parchoice == 'C') {
                    //$('[name="cst-nstep_wwm"]').removeAttr('disabled');
                    $(all_par_inputs).each(function(){
                        if ($(this).prop('required') && $(this).val() == '') {
                            flagok = false;
                            msg = '{% trans "Para continuar terá de preencher todos os campos." %}';
                            return false;
                        }
                        if (!this.validity.valid) {
                            flagok = false;
                            msg = '{% trans "Para continuar terá de corrigir os campos inválidos." %}';
                            return false;
                        }
                    });
                }

                if (!flagok) {
                    $('#msg_str').html(msg);
                    $('#divModal_msg').modal('show');
                    return false;
                }

                {% if 'yes' in waves_type %}
                var all_wwm_inputs = '#waves input, #waves select';
                var wwmchoice = $('[name="parchoice"]:checked').val();
                if (wwmchoice == 'D') {
                    // reject values from inputs in 'C' wwmchoice
                    $(all_wwm_inputs).removeAttr('required');
                } else if (wwmchoice == 'C') {
                    //$('[name="cst-nstep_wwm"]').removeAttr('disabled');
                    $(all_wwm_inputs).each(function(){
                        if ($(this).prop('required') && $(this).val() == '') {
                            flagok = false;
                            msg = '{% trans "Para continuar terá de preencher todos os campos." %}';
                            return false;
                        }
                        if (!this.validity.valid) {
                            flagok = false;
                            msg = '{% trans "Para continuar terá de corrigir os campos inválidos." %}';
                            return false;
                        }
                    });
                }
                {% endif %}

                if (!flagok) {
                    $('#msg_str').html(msg);
                    $('#divModal_msg').modal('show');
                    return false;
                }

                $('#divModal_processing').modal('show');

                var btnname = e.currentTarget.name;
                if (btnname == 'edit') {
                    e.preventDefault();

                    var cType = 'application/x-www-form-urlencoded; charset=UTF-8', pData = true;
                    {% if file_upload_allowed %}
                    if (parchoice == 'U') {
                        $.ajaxSetup({beforeSend: function(xhr, settings){
                            xhr.setRequestHeader('X-CSRFToken', '{{ csrf_token }}');
                        }});
                        cType = false;
                        pData = false;
                        var formdata = new FormData($('.form').get(0));
                    } else {
                        var formdata = $('.form').serialize();
                    }
                    {% else %}
                    var formdata = $('.form').serialize();
                    {% endif %}

                    // Send form data via client-side
                    $.ajax({
                        type: 'POST',
                        url: '{% url 'wizard:save_steps' step=0 %}'.replace(/0/, step),
                        data: formdata,
                        contentType: cType,
                        processData: pData,
                        success: function(data) {
                            $('#divModal_processing').modal('hide');

                            if (data['msg']) {
                                $('#msg_str').html(data['msg']);
                                $('#divModal_msg').modal('show');
                            }
                        },
                        error: function(e, x, r) {
                            console.log(r + ' - ' + e);
                            $('#divModal_processing').modal('hide');

                            $('#msg_str').html('{% trans "Ocorreu um erro! Por favor tente mais tarde." %}');
                            $('#divModal_msg').modal('show');
                        }
                    });
                }
            } catch(err) {
                e.preventDefault();
                console.log(err);
                $('#divModal_processing').modal('hide');

                $('#msg_str').html('{% trans "Ocorreu um erro! Por favor tente mais tarde." %}');
                $('#divModal_msg').modal('show');
            }
        });

        // On Document Ready
        $(function(){

            // Hide/Show Forms on load
            toggleForms();
            //toggleForms_wwm();

            {% if flag_check %}
            let custom_inputs =  document.getElementsByClassName('user_customizable');

            for(var i = 0; i < custom_inputs.length; i++){
                custom_inputs[i].disabled = true;
            }
            {% else %}
            let custom_inputs =  document.getElementsByClassName('user_customizable');

            for(var i = 0; i < custom_inputs.length; i++){
                custom_inputs[i].disabled = false;
            }
            {% endif %}

            // JQuery Table
            $('#pardefault_table').DataTable({
                "paging":    true,
                "ordering":  false,
                "info":      false,
                "searching": true,
                "pagingType": "full",
                "autoWidth": false,
                "lengthMenu": [ [10, -1], [10, "{% trans 'Todos' %}"] ],
                "columnDefs": [
                    { "visible": false, "targets": 0 }
                ],
                "language":
                    {
                        "emptyTable":       "{% trans 'Sem registos' %}",
                        "search":           "{% trans 'Pesquisar' %}",
                        "lengthMenu":       "_MENU_ {% trans 'linhas' %}",
                        "paginate":
                        {
                            "previous": "<",
                            "next": ">",
                            "first": "<<",
                            "last": ">>"
                        }
                    },
                "drawCallback": function ( settings ) {
                    var api = this.api();
                    var rows = api.rows( {page:'current'} ).nodes();

                    var last = null;
                    // Group rows
                    api.column(0, {page:'current'} ).data().each( function ( group, i ) {
                        if ( last !== group ) {
                            $(rows).eq( i ).before(
                                //'<tr class="group"><td colspan="3">' + group + '</td></tr>'
                                '<tr class="group"><td>' + group + '</td></tr>'
                            );
                            last = group;
                        }
                    } );

                    // Hide Pagination on All records
                    var this_table = $(this).closest('.dataTables_wrapper');
                    var pagination = this_table.find('.dataTables_paginate');
                    pagination.toggle(this.api().page.info().pages > 1);

                    // If toggle comments is active hide comments (tr.group)
                    var tglcmts = this_table.find('.tglcmts');
                    if ($(tglcmts).hasClass("active")) {
                        $(this_table).find('tr.group').hide();
                        $(this_table).find('.label-comment').hide();
                    } else {
                        $(this_table).find('tr.group').show();
                        $(this_table).find('.label-comment').show();
                    }
                }
            });

            {% if 'yes' in waves_type %}
            $('#wwmdefault_table').DataTable({
                "paging":    true,
                "ordering":  false,
                "info":      false,
                "searching": true,
                "pagingType": "full",
                "autoWidth": false,
                "lengthMenu": [ [10, -1], [10, "{% trans 'Todos' %}"] ],
                "columnDefs": [
                    { "visible": false, "targets": 0 }
                ],
                "language":
                    {
                        "emptyTable":       "{% trans 'Sem registos' %}",
                        "search":           "{% trans 'Pesquisar' %}",
                        "lengthMenu":       "_MENU_ {% trans 'linhas' %}",
                        "paginate":
                        {
                            "previous": "<",
                            "next": ">",
                            "first": "<<",
                            "last": ">>"
                        }
                    },
                "drawCallback": function ( settings ) {
                    var api = this.api();
                    var rows = api.rows( {page:'current'} ).nodes();

                    var last = null;
                    // Group rows
                    api.column(0, {page:'current'} ).data().each( function ( group, i ) {
                        if ( last !== group ) {
                            $(rows).eq( i ).before(
                                //'<tr class="group"><td colspan="3">' + group + '</td></tr>'
                                '<tr class="group"><td>' + group + '</td></tr>'
                            );
                            last = group;
                        }
                    } );

                    // Hide Pagination on All records
                    var this_table = $(this).closest('.dataTables_wrapper');
                    var pagination = this_table.find('.dataTables_paginate');
                    pagination.toggle(this.api().page.info().pages > 1);

                    // If toggle comments is active hide comments (tr.group)
                    var tglcmts = this_table.find('.tglcmts');
                    if ($(tglcmts).hasClass("active")) {
                        $(this_table).find('tr.group').hide();
                        $(this_table).find('.label-comment').hide();
                    } else {
                        $(this_table).find('tr.group').show();
                        $(this_table).find('.label-comment').show();
                    }
                }
            });
            {% endif %}

            // Set Events to fields in form
            $('[data-ruleset]').each(function(i, obj){
                // Get field to attach event
                var fieldname = $(obj).attr('name');
                if ($(obj).is('input[type="radio"]')) {
                    // event to parent
                    var field = $('[name="' + fieldname + '"]');
                } else {
                    // event to itself
                    var field = $(obj);
                }

                var json = JSON.parse($(this).attr('data-ruleset').replace(/'/g, '"'));
                var functions = json.functions;

                // If load event applies immediately
                if ('load' in functions) {
                    // Evaluate load conditions
                    var flagload = eval(loadConditions(field));
                    if (flagload) {
                        field.closest(".fieldWrapper").show();
                    } else {
                        field.closest(".fieldWrapper").hide();
                    }
                }

                if ('change' in functions) {
                    // Attach event to field
                    field.on('change', function() {
                        // Blur this input
                        $('[name="' + fieldname + '"]').blur();

                        // Get selected value from field
                        var value = getVal(fieldname);

                        // Get functions change array
                        var conditions = functions['change'];

                        // loop through evaluate conditions
                        for (var i=0; i<conditions.length; i++) {
                            var cval = conditions[i].value;

                            // load/unload fields
                            if ('load' in conditions[i]) {
                                var arr1 = conditions[i].load.split(',');
                                for (var j=0; j<arr1.length; j++) {
                                    var auxfield = $('[name="cst-' + arr1[j] + '"]');

                                    // Evaluate load conditions, check also for field's own rules
                                    var flagload = eval(loadConditions(auxfield));
                                    if (flagload && eval(value + cval)) {
                                        auxfield.closest(".fieldWrapper").show();
                                    } else {
                                        auxfield.closest(".fieldWrapper").hide();
                                    }
                                }
                            }

                            // set fields values if condition met
                            if ('set' in conditions[i] && eval(value + cval)) {
                                var arr2 = conditions[i].set.split(',');
                                for (var j=0; j<arr2.length; j++) {
                                    var arr3 = arr2[j].split(new RegExp('[<=>/:?]', 'g'));
                                    // get field to be set and new value
                                    var cfield = $('[name="cst-' + arr3[0] + '"]');
                                    var cfieldvalue = arr3[1];
                                    // change value, min or max
                                    if (arr2[j].indexOf('=') > -1) {
                                        cfield.attr("value", cfieldvalue);
                                    } else if (arr2[j].indexOf('<') > -1) {
                                        cfield.attr("max", cfieldvalue);
                                    } else if (arr2[j].indexOf('>') > -1) {
                                        cfield.attr("min", cfieldvalue);
                                    }
                                }
                            }

                            // change field value to result of condition
                            if ('change' in conditions[i]) {
                                var dname = String(conditions[i]['change']).replace('$', '');
                                var dvalue = conditions[i]['value'];
                                var dcondition = ('if' in conditions[i]) ? conditions[i]['if'] : null;
                                if (dname == dname.toLowerCase()) {
                                    dname = 'cst-' + dname;
                                } else {
                                    // If field name in uppercase then its a wwm field
                                    dname = 'cst_wwm-' + dname;
                                }
                                // Get the field to change
                                var field = $('[name="' + dname + '"]');
                                if (typeof dvalue ==='string') {
                                    // Field's value depends on an operation
                                    var fsaux = dvalue.split(new RegExp('[-\*\/=]', 'g'));

                                    for (var i=0; i<fsaux.length; i++) {
                                        var faux = fsaux[i];
                                        if (faux.indexOf('$') > -1) {
                                            // Depends on another field, replace field reference with its value
                                            // Get value to replace
                                            var name = faux.replace('$', '');
                                            if (name == name.toLowerCase()) {
                                                name = 'cst-' + name;
                                            } else {
                                                // If field name in uppercase then its a wwm field
                                                name = 'cst_wwm-' + name;
                                            }
                                            var val = getVal(name);
                                            if (typeof val != "undefined") dvalue = dvalue.replace(fsaux[i], val);
                                        }
                                    }
                                    dvalue = eval(dvalue);
                                    if (dcondition == null) {
                                       field.val(dvalue);
                                    } else if (dcondition == 'isInteger') {
                                        if (Number.isInteger(dvalue)) field.val(dvalue);
                                    }
                                } else {
                                    field.val(dvalue);
                                }
                            }
                        }
                    });
                }

                if ('validate' in functions) {
                    // validation conditions for this field
                    var str_fct = '';
                    var evals = functions['validate'];
                    for (var i=0; i<evals.length; i++) {
                        var del = evals[i]['eval'];
                        var val = evals[i]['value'];
                        if (val.indexOf('$') > -1) val = '"' + val + '"';
                        str_fct += "validateField('" + fieldname + "','" + del + "'," + val + ");"
                    }
                    field.attr("onchange", str_fct);
                }
            });

            // Group fields by data-category
            var category = null;
            $('[data-category]').each(function(){
                var cat = $(this).attr('data-category');
                if (cat != category) {
                    if (cat == 'None') cat = '';
                    $(this).closest(".fieldWrapper").before("<p class='grouptitle'>" + cat + "</p>");
                }
                category = cat;
            });

            // Create hide and show comments button
            var tglcmts = document.createElement('button');
            $(tglcmts).addClass('btn btn-primary btn-xs tglcmts');
            $(tglcmts).attr('type', "button");
            $(tglcmts).attr('data-toggle', "tooltip");
            $(tglcmts).attr('data-placement', "top");
            $(tglcmts).attr('title', "{% trans 'Esconder comentários' %}");
            $(tglcmts).attr('data-title', "{% trans 'Esconder comentários' %}");
            $(tglcmts).attr('data-title_alt', "{% trans 'Mostrar comentários' %}");
            $(tglcmts).html('<span class="glyphicon glyphicon-text-height"></span>');
            $(tglcmts).click(function(){
                var self = $(this);
                // Toggle Class
                self.toggleClass('active');

                // Toggle tooltip title
                var this_table = self.parent();
                if (self.hasClass("active")) {
                    self.attr("title", self.attr('data-title_alt'));
                    $(this_table).find('tr.group').hide();
                    $(this_table).find('.label-comment').hide();
                } else {
                    self.attr("title", self.attr('data-title'));
                    $(this_table).find('tr.group').show();
                    $(this_table).find('.label-comment').show();
                }
                self.tooltip('fixTitle');
                self.blur();
            });
            $(tglcmts).tooltip();

            // Add button next to Table Length input
            $('.dataTables_length').after(tglcmts);
        });
    </script>

    <!-- Load JQuery dataTables -->
    <script src="{% static 'vendor/jquery-dataTables/jquery.dataTables.min.js' %}"></script>

{% endblock content %}
